local n = neutrino(0, 0, SCREEN.X_RES, SCREEN.Y_RES);
n:checkVersion(1, 31);

json = require "json"

if #arg < 1 then return nil end
local _url=""
local ret = {}

local login = ""
local pw = ""
local quality = 3

local cfn = "/var/tuxbox/config/ustvnow.conf"
local ckn = "/tmp/ustvnow.cks"
local rfn = os.tmpname()

function url_encode(str)
	if (str) then
		str = string.gsub (str, "\n", "\r\n")
		str = string.gsub (str, "([^%w %-%_%.%~])",
			function (c) return string.format ("%%%02X", string.byte(c)) end)
		str = string.gsub (str, " ", "+")
	end
	return str
end

function dologin()
  os.execute('curl -A "Mozilla/5.0" --cookie-jar '
    .. ckn
	.. ' -H "Content-Type:application/x-www-form-urlencoded"'
    .. ' -e http://m.ustvnow.com/'
	.. ' -X POST -d "username=' .. url_encode(login) .. '&password=' .. url_encode(pw) .. '&device=iphone"'
    .. ' -o ' .. rfn
	..' "http://m.ustvnow.com/iphone/1/live/login"')
end

function httpget(url)
  os.execute('curl -A "Mozilla/5.0" -o ' .. rfn .. ' --cookie '  .. ckn .. ' -e  http://m.ustvnow.com/ "' .. url .. '"');
  local fp = io.open(rfn, "r")
  if fp == nil then return nil end
  local s=fp:read("*a")
  fp:close()
  return s
end

function findchurl(cnt,ch)
  local i,j=cnt:find('<li data%-filtertext="'..ch..'.-ui%-page=')
  if j==nil then return nil end
  local s=cnt:match('(.-)"',j+1)
  if s==nil then return nil end
  s=cnt:match('for="popup%-'..s..'.-iphone/(.-)"',j+s:len())
  if s==nil then return nil end
  return 'http://m.ustvnow.com/iphone/'..s
end

function getVideoData()
  local cnt=httpget("http://m.ustvnow.com/iphone/1/live/playingnow")
  if cnt==nil then return 0 end
  local churl=findchurl(cnt,_url)
  if churl==nil then return 0 end
  cnt=httpget(churl)
  if cnt==nil then return 0 end
  local m3u8 = cnt:match('src="(.-)"')
  if m3u8==nil then return 0 end
  
  m3u8=m3u8:gsub('mp4:','smil:')
  m3u8=m3u8:gsub('USTVNOW1','USTVNOW')
  
  local base = m3u8:match('(.*)/')
  if base==nil then return 0 end
  
  cnt=httpget(m3u8)
  if cnt==nil then return 0 end

  local c=0
  local cbw=0
  local cq=0
  local item
  local bw=0
  for b,r1,r2,u in cnt:gmatch(
    '#EXT.X.STREAM.INF.BANDWIDTH=(%d+).-RESOLUTION=(%d+)x(%d+).-\n(.-)\n') do
    if u ~= nil then
      item={url= base .. '/' .. u,name=_url,band=b,res1=r1,res2=r2}
      if quality==0 then
        c=c+1
        ret[c]=item
      else
        bw=tonumber(b) 
        if (bw>cbw) then
          cbw=bw
          c=1
          ret[1]=item
          cq=cq+1
          if cq>=quality then break end
       end  
      end
    end
  end
  return c
end

function main()
  _url=arg[1]
  do
    local cf=configfile.new()
    cf:loadConfig(cfn)
    login=cf:getString("login", "")
    pw=cf:getString("password","")
    quality=cf:getInt32("quality",3)
  end
  if getVideoData()<1 then
    dologin()
    getVideoData()
  end
end

pcall(main)
os.execute('rm '..rfn)
--os.execute('rm '..ckn) 
if next(ret)==nil then
  return ""
end
return json:encode(ret)